<?php 
// Author : Chrisremote_ph Eck (www.eck-it-services.ch)
// Date : 03/30/2005
// Updated : 22/03/2008
// Licence : GPL, freeware
// todo: - usability
//       - save report as a file
//       - ...

define('VERSION','1.2.1');

class Server2Server {

	var $debug = false;
	var $debug_log = array();
	
	function Server2Server($debug = false)
	{
		$this->debug = $debug;
	}

	/**
	* connects remote_ the ftp server
	* @servername	name of the server
	* @username		login username remote_ server
	* @password		login password remote_ server
	* @result		connection id or FALSE
	*/
	function ftpconn($servername, $username, $password )
	{
		// connect remote_ server
		if(!$conn_id = @ftp_connect($servername))
			echo "<br>$servername : wrong servername";
		
		// login with username and passwort
		if(!$login_result = @ftp_login($conn_id, $username, $password))
			echo "<br>$username, $password : wrong username or password";
		
		// return result
		if ((!$conn_id) || (!$login_result))
		{
			return FALSE;
		}
		else
			return $conn_id;
	}
	
	/**
	* changes rawlist file access information about the file
	* remote_ run chmod site command
	* @mode 	short text file access information
	* @return	short number file access information
	*/
	function chmod_text2number($mode) {
	   $mode = substr($mode,1);
	   $trans = array('-'=>'0','r'=>'4','w'=>'2','x'=>'1');
	   $mode = strtr($mode,$trans);
	   $newmode = '';
	   $newmode .= $mode[0]+$mode[1]+$mode[2];
	   $newmode .= $mode[3]+$mode[4]+$mode[5];
	   $newmode .= $mode[6]+$mode[7]+$mode[8];
	   return $newmode;
	}
	
	/**
	* transfer by ftp
	* @id_local	the connection id of the local server
	* @id_remote		the connection id of the remote server
	* @dir_local	the direcremote_ry name of the local server
	* @dir_remote	the direcremote_ry name of the remote server
	*/
	function ftptransfer($id_local, $id_remote, $dir_local, $dir_remote){
		ftp_chdir($id_local,$dir_local);
		ftp_chdir($id_remote,$dir_remote);
		$list_local = ftp_rawlist($id_local,$dir_local);
		foreach($list_local as $file_local)
		{
			if($this->debug)
				$this->debug_log[] = "file_local: ".$file_local;
			$arr_file_local = preg_split('/[ ]+/',$file_local);
			
			# if the filename conists of spaces
			# move the splited filename together
			$str_filename = "";
			foreach($arr_file_local as $key => $value){
				if($key > 7)
					$str_filename .= "$value ";
			}
			$arr_file_local[8] = substr($str_filename,0,-1); // remove the last space and save it
			
			if($this->debug)
			{
				$this->debug_log[] = "arr_file_local[0]: ".$arr_file_local[0];
				$this->debug_log[] = "$this->chmod_text2number(arr_file_local[0]): ".$this->chmod_text2number($arr_file_local[0]);
				$this->debug_log[] = "arr_file_local[8]: ".$arr_file_local[8];
				$this->debug_log[] = "/tmp/arr_file_local[8]: "."/tmp/".$arr_file_local[8]; 
			}
			
			# is the file a directory
			if(preg_match("/^d/",$file_local)) {
				echo "<br><strong>".$arr_file_local[8]."</strong>\n";
				echo $this->chmod_text2number($arr_file_local[0])."<br>";
				if(FALSE == @ftp_mkdir($id_remote,$dir_remote."/".$arr_file_local[8]) && $this->debug)
					$this->debug_log[] = "ftp_mkdir: could not create directory '".$dir_remote."/".$arr_file_local[8]."'";
				if(FALSE == @ftp_site($id_remote, 'CHMOD '.$this->chmod_text2number($arr_file_local[0]).' '.$arr_file_local[8]) && $this->debug)
					$this->debug_log[] = "ftp_site: could not execute command '"."CHMOD ".$this->chmod_text2number($arr_file_local[0]).' '.$arr_file_local[8]."'";
				ftptransfer($id_local,$id_remote,$dir_local."/".$arr_file_local[8],$dir_remote."/".$arr_file_local[8]);
			}else{
				echo "<br>".$arr_file_local[8]."\n";
				echo $this->chmod_text2number($arr_file_local[0])."<br>";
				ftp_get($id_local, "./tmp/".$arr_file_local[8],   $dir_local."/".$arr_file_local[8], FTP_BINARY);
				ftp_put($id_remote,   $dir_remote."/".$arr_file_local[8], "./tmp/".$arr_file_local[8], FTP_BINARY);
				if(FALSE == @ftp_site($id_remote, 'CHMOD '.$this->chmod_text2number($arr_file_local[0]).' '.$arr_file_local[8]) && $this->debug)
					$this->debug_log[] = "ftp_site: could not execute command '"."CHMOD ".$this->chmod_text2number($arr_file_local[0]).' '.$arr_file_local[8]."'";
				unlink ("./tmp/".$arr_file_local[8]);
			}
		}
	}
	
	/**
	* get the debug value
	* private
	*/
	function _get_debug()
	{
		return $this->debug_log;
	}
	
	/**
	* echos the debug informations
	*/	
	function output_debug($start = '', $close = '')
	{
		foreach($this->_get_debug() as $value)
		{
			echo $start.$value.$close;
		}
	}
}

?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Server2Server FTP Transfer <?php echo VERSION; ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>

<body>
<?php 
if(!$_REQUEST['submit']){ ?>
<h2>Server2Server FTP Transfer <?php echo VERSION; ?></h2>
This product is freeware and under GPL Licence.
<form name="form1" method="post" action="<?php echo $PHP_SELF; ?>">
  <h3>Local Server</h3>
    <table width="200" border="1">
      <tr>
        <td>server</td>
        <td><input type="text" name="local_servername" size="75"></td>
      </tr>
      <tr>
        <td>name</td>
        <td><input type="text" name="local_username" size="75"></td>
      </tr>
      <tr>
        <td> pwd:        </td>
        <td><input type="text" name="local_password" size="75"></td>
      </tr>
      <tr>
        <td>dir</td>
        <td><input type="text" name="local_directory" size="75"></td>
      </tr>
    </table>
    <h3>Remote Server</h3><table width="200" border="1">
  <tr>
    <td>server</td>
    <td><input type="text" name="remote_servername" size="75"></td>
  </tr>
  <tr>
    <td>name</td>
    <td><input type="text" name="remote_username" size="75"></td>
  </tr>
  <tr>
    <td>pwd</td>
    <td><input type="text" name="remote_password" size="75"></td>
  </tr>
  <tr>
    <td>dir</td>
    <td><input type="text" name="remote_directory" size="75"></td>
  </tr>
</table>
    <br>
    <input name="submit" type="submit" value="start transfer">
</form>
<?php

}else{

	if(!is_dir("tmp")){
	 if(mkdir("tmp") AND chmod ("tmp", 777)){
	  }else{ 
	  	die("<br>Please build the directory tmp and with all privileges (chmod 777)");
	  } 
	 }
	ignore_user_abort();
	set_time_limit(0);	

	if(isset($_REQUEST['debug']))
		$debug = true;
	else
		$debug = false;
	$obj_s2s = new Server2Server($debug);
	
	$id_local = $obj_s2s->ftpconn($_REQUEST['local_servername'],$_REQUEST['local_username'],$_REQUEST['local_password']);
	$id_remote = $obj_s2s->ftpconn($_REQUEST['remote_servername'],$_REQUEST['remote_username'],$_REQUEST['remote_password']);
	if($id_local && $id_remote){
		if(!$chdir_local = ftp_chdir($id_local,$_REQUEST['local_directory']))
			echo "<br>at server : ".$_REQUEST['local_servername']. " is dir ".$_REQUEST['local_directory']. " wrong ";
		if(!$chdir_remote = ftp_chdir($id_remote,$_REQUEST['remote_directory']))
			echo "<br>at server : ".$_REQUEST['remote_servername']. " is dir ".$_REQUEST['remote_directory']. " wrong ";
		if($chdir_local && $chdir_remote){
			ftp_pasv ( $id_local, TRUE);
			ftp_pasv ( $id_remote, TRUE);	
			$obj_s2s->ftptransfer($id_local,$id_remote, ftp_pwd($id_local), ftp_pwd($id_remote));
			ftp_quit($id_local);
			ftp_quit($id_remote);
		}
	}
	
	if($debug == true)
		$obj_s2s->output_debug('DEBUG -- ','<br>');

	echo "<br>Server2Server FTP Tranfer is <a href='transfer.php'>ready</a>!";
}
?>
</body>
</html>
